"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _CodeEditor = _interopRequireDefault(require("./CodeEditor"));

var _autobindDecorator = _interopRequireDefault(require("autobind-decorator"));

var _class;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

var CodeEditorDialog = (_class = /*#__PURE__*/function () {
  function CodeEditorDialog(editor) {
    _classCallCheck(this, CodeEditorDialog);

    this.editor = editor;
    this.active = false;
    this.$container = null;
    this.codeEditor = null;
  }

  _createClass(CodeEditorDialog, [{
    key: "open",
    value: function open() {
      if (this.active) {
        return;
      }

      if (!this.$container) {
        this.createContainer();
      }

      this.$container.show();
      this.$container.offset();
      this.$container.addClass('mce-in');
      this.codeEditor.refresh();
      this.active = true;
    }
  }, {
    key: "close",
    value: function close() {
      if (!this.active) {
        return;
      }

      this.$container.removeClass('mce-in');
      this.$container.offset();
      this.$container.hide();
      this.active = false;
    }
  }, {
    key: "handleClose",
    value: function handleClose(e) {
      this.close();
    }
  }, {
    key: "createContainer",
    value: function createContainer() {
      var _this = this;

      var _this$editor = this.editor,
          $ = _this$editor.$,
          dom = _this$editor.dom;
      var container = dom.add(document.body, 'div', {
        "class": 'mce-codeblock-dialog-container'
      });
      var shadow = dom.add(container, 'div', {
        "class": 'mce-codeblock-shadow'
      });
      var dialog = dom.add(container, 'div', {
        "class": 'mce-codeblock-dialog'
      });
      var header = dom.add(dialog, 'div', {
        "class": 'mce-codeblock-header mce-window-head'
      }, '<span class="mce-codeblock-title mce-title">코드블럭 삽입</span>');
      var languageSelect = dom.add(header, 'select', {
        "class": 'mce-codeblock-language'
      }, '<option>TEXT</option>');
      var content = dom.add(dialog, 'div', {
        "class": 'mce-codeblock-content'
      });
      var textarea = dom.add(content, 'textarea', {
        "class": 'textarea'
      });
      var footer = dom.add(dialog, 'div', {
        "class": 'mce-codeblock-footer'
      });
      var btnCancel = dom.add(footer, 'button', {
        "class": 'mce-codeblock-btn mce-codeblock-btn-cancel'
      }, '취소');
      var btnSubmit = dom.add(footer, 'button', {
        "class": 'mce-codeblock-btn mce-codeblock-btn-submit',
        disabled: true
      }, '확인');
      this.$container = $(container);
      var $btnSubmit = $(btnSubmit);
      this.createEditor(textarea, languageSelect, function (value) {
        if (value && value.length > 0) {
          $btnSubmit.attr('disabled', null);
        } else {
          $btnSubmit.attr('disabled', true);
        }
      });
      $btnSubmit.on('click', function () {
        if (!_this.active) {
          return;
        }

        _this.codeEditor.insertCodeBlock();

        _this.close();
      });
      $(btnCancel).on('click', this.handleClose);
      $(shadow).on('click', this.handleClose);
    }
  }, {
    key: "createEditor",
    value: function createEditor(textarea, languageSelect, onChange) {
      this.codeEditor = new _CodeEditor["default"](this.editor, textarea, languageSelect);
      this.codeEditor.onChange(onChange);
    }
  }]);

  return CodeEditorDialog;
}(), (_applyDecoratedDescriptor(_class.prototype, "handleClose", [_autobindDecorator["default"]], Object.getOwnPropertyDescriptor(_class.prototype, "handleClose"), _class.prototype)), _class);
var _default = CodeEditorDialog;
exports["default"] = _default;